stx-metal: add kickstart fixes for poky-stx
[pti/rtp.git] / meta-stx / conf / distro / files / ks / net_storage_ks.cfg
1 #
2 # Copyright (c) 2019 Wind River Systems, Inc.
3 # SPDX-License-Identifier: Apache-2.0
4 #
5
6 %pre
7 # This file defines functions that can be used in %pre and %post kickstart sections, by including:
8 # . /tmp/ks-functions.sh
9 #
10
11 cat <<END_FUNCTIONS >/tmp/ks-functions.sh
12 #
13 # Copyright (c) 2019 Wind River Systems, Inc.
14 #
15 # SPDX-License-Identifier: Apache-2.0
16 #
17
18 function get_by_path()
19 {
20     local disk=\$(cd /dev ; readlink -f \$1)
21     for p in /dev/disk/by-path/*; do
22         if [ "\$disk" = "\$(readlink -f \$p)" ]; then
23             echo \$p
24             return
25         fi
26     done
27 }
28
29 function get_disk()
30 {
31     echo \$(cd /dev ; readlink -f \$1)
32 }
33
34 function report_pre_failure_with_msg()
35 {
36     local msg=\$1
37     echo -e '\n\nInstallation failed.\n'
38     echo "\$msg"
39
40     exit 1
41 }
42
43 function report_post_failure_with_msg()
44 {
45     local msg=\$1
46     cat <<EOF >> /etc/motd
47
48 Installation failed.
49 \$msg
50
51 EOF
52     echo "\$msg" >/etc/platform/installation_failed
53
54     echo -e '\n\nInstallation failed.\n'
55     echo "\$msg"
56
57     exit 1
58 }
59
60 function report_post_failure_with_logfile()
61 {
62     local logfile=\$1
63     cat <<EOF >> /etc/motd
64
65 Installation failed.
66 Please see \$logfile for details of failure
67
68 EOF
69     echo \$logfile >/etc/platform/installation_failed
70
71     echo -e '\n\nInstallation failed.\n'
72     cat \$logfile
73
74     exit 1
75 }
76
77 function get_http_port()
78 {
79     echo \$(cat /proc/cmdline |xargs -n1 echo |grep '^inst.repo=' | sed -r 's#^[^/]*://[^/]*:([0-9]*)/.*#\1#')
80 }
81
82 END_FUNCTIONS
83
84 %end
85
86 %post
87 # This file defines functions that can be used in %pre and %post kickstart sections, by including:
88 # . /tmp/ks-functions.sh
89 #
90
91 cat <<END_FUNCTIONS >/tmp/ks-functions.sh
92 #
93 # Copyright (c) 2019 Wind River Systems, Inc.
94 #
95 # SPDX-License-Identifier: Apache-2.0
96 #
97
98 function get_by_path()
99 {
100     local disk=\$(cd /dev ; readlink -f \$1)
101     for p in /dev/disk/by-path/*; do
102         if [ "\$disk" = "\$(readlink -f \$p)" ]; then
103             echo \$p
104             return
105         fi
106     done
107 }
108
109 function get_disk()
110 {
111     echo \$(cd /dev ; readlink -f \$1)
112 }
113
114 function report_pre_failure_with_msg()
115 {
116     local msg=\$1
117     echo -e '\n\nInstallation failed.\n'
118     echo "\$msg"
119
120     exit 1
121 }
122
123 function report_post_failure_with_msg()
124 {
125     local msg=\$1
126     cat <<EOF >> /etc/motd
127
128 Installation failed.
129 \$msg
130
131 EOF
132     echo "\$msg" >/etc/platform/installation_failed
133
134     echo -e '\n\nInstallation failed.\n'
135     echo "\$msg"
136
137     exit 1
138 }
139
140 function report_post_failure_with_logfile()
141 {
142     local logfile=\$1
143     cat <<EOF >> /etc/motd
144
145 Installation failed.
146 Please see \$logfile for details of failure
147
148 EOF
149     echo \$logfile >/etc/platform/installation_failed
150
151     echo -e '\n\nInstallation failed.\n'
152     cat \$logfile
153
154     exit 1
155 }
156
157 function get_http_port()
158 {
159     echo \$(cat /proc/cmdline |xargs -n1 echo |grep '^inst.repo=' | sed -r 's#^[^/]*://[^/]*:([0-9]*)/.*#\1#')
160 }
161
162 END_FUNCTIONS
163
164 %end
165
166
167 # Template from: pre_common_head.cfg
168 %pre --erroronfail
169
170 # Source common functions
171 . /tmp/ks-functions.sh
172
173 # First, parse /proc/cmdline to find the boot args
174 set -- `cat /proc/cmdline`
175 for I in $*; do case "$I" in *=*) eval $I 2>/dev/null;; esac; done
176
177 append=
178 if [ -n "$console" ] ; then
179     append="console=$console"
180 fi
181
182 if [ -n "$security_profile" ]; then
183     append="$append security_profile=$security_profile"
184 fi
185
186 #### SECURITY PROFILE HANDLING (Pre Installation) ####
187 if [ -n "$security_profile" ] && [ "$security_profile" == "extended" ]; then
188     # IMA specific boot options:
189     # Enable Kernel auditing
190     append="$append audit=1"
191 else
192     # we need to blacklist the IMA and Integrity Modules
193     # on standard security profile
194     append="$append module_blacklist=integrity,ima"
195     
196     # Disable Kernel auditing in Standard Security Profile mode
197     append="$append audit=0"
198 fi
199
200 if [ -n "$tboot" ]; then
201     append="$append tboot=$tboot"
202 else
203     append="$append tboot=false"
204 fi
205
206 boot_device_arg=
207 if [ -n "$boot_device" ] ; then
208     boot_device_arg="--boot-drive=$(get_by_path $boot_device)"
209 fi
210
211 echo "bootloader --location=mbr $boot_device_arg --timeout=5 --append=\"$append\"" > /tmp/bootloader-include
212
213 echo "timezone --nontp --utc UTC" >/tmp/timezone-include
214 %end
215
216 #version=DEVEL
217 install
218 lang en_US.UTF-8
219 keyboard us
220 %include /tmp/timezone-include
221 # set to 'x' so we can use shadow password
222 rootpw  --iscrypted x
223 selinux --disabled
224 authconfig --enableshadow --passalgo=sha512
225 firewall --service=ssh
226
227 # The following is the partition information you requested
228 # Note that any partitions you deleted are not expressed
229 # here so unless you clear all partitions first, this is
230 # not guaranteed to work
231 zerombr
232
233 # Disk layout from %pre
234 %include /tmp/part-include
235 # Bootloader parms from %pre
236 %include /tmp/bootloader-include
237
238 reboot --eject
239
240
241 # Template from: pre_net_common.cfg
242 %pre
243
244 # Setup ntp.conf and sync time
245 cat <<EOF >/etc/ntp_kickstart.conf
246 server pxecontroller
247 EOF
248
249 /usr/sbin/ntpd -g -q -n -c /etc/ntp_kickstart.conf
250 if [ $? -eq 0 ]; then
251     /sbin/hwclock --systohc --utc
252 fi
253
254 %end
255
256
257 # Template from: pre_pkglist.cfg
258 %packages
259 @core
260 @base
261 -kernel-module-igb-uio-rt
262 -kernel-module-wrs-avp-rt
263 -kernel-rt
264 -kernel-rt-kvm
265 -kernel-rt-tools
266 -kernel-rt-tools-libs
267 -kmod-drbd-rt
268 -kmod-e1000e-rt
269 -kmod-i40e-rt
270 -kmod-ixgbe-rt
271 -kmod-tpm-rt
272 -mlnx-ofa_kernel
273 -mlnx-ofa_kernel-rt
274 -mlnx-ofa_kernel-rt-modules
275 -qat16-rt
276 @platform-storage
277 @updates-storage
278 %end
279
280
281 # Template from: pre_disk_setup_common.cfg
282 %pre --erroronfail
283
284 # Source common functions
285 . /tmp/ks-functions.sh
286
287 # This is a really fancy way of finding the first usable disk for the
288 # install and not stomping on the USB device if it comes up first
289
290 # First, parse /proc/cmdline to find the boot args
291 set -- `cat /proc/cmdline`
292 for I in $*; do case "$I" in *=*) eval $I 2>/dev/null;; esac; done
293
294 # Find either the ISO or USB device first chopping off partition
295 ISO_DEV=`readlink /dev/disk/by-label/oe_iso_boot`
296 sdev=`echo $ISO_DEV | sed -e 's/.$//'`
297 if [ -e /dev/disk/by-label/$sdev ] ; then
298     ISO_DEV=$sdev
299 fi
300 USB_DEV=`readlink /dev/disk/by-label/wr_usb_boot`
301 sdev=`echo $USB_DEV | sed -e 's/.$//'`
302 if [ -e /dev/disk/by-label/$sdev ] ; then
303     USB_DEV=$sdev
304 fi
305
306 # Temporary, until lab pxelinux.cfg files are updated to specify install devices
307 if [ -z "$rootfs_device" -o -z "$boot_device" ]
308 then
309     INST_HDD=""
310     # Prefer a vd* device if this is kvm/qemu
311     for e in vda vdb sda sdb nvme0n1; do
312         if [ -e /dev/$e -a "$ISO_DEV" != "../../$e" -a "$USB_DEV" != "../../$e" ] ; then
313             INST_HDD=$e
314             break
315         fi
316     done
317
318     # Set variables to $INST_HDD if not set
319     rootfs_device=${rootfs_device:-$INST_HDD}
320     boot_device=${boot_device:-$INST_HDD}
321 fi
322
323 # Convert to by-path
324 orig_rootfs_device=$rootfs_device
325 rootfs_device=$(get_by_path $rootfs_device)
326
327 orig_boot_device=$boot_device
328 boot_device=$(get_by_path $boot_device)
329
330 if [ ! -e "$rootfs_device" -o ! -e "$boot_device" ] ; then
331     # Touch this file to prevent Anaconda from dying an ungraceful death
332     touch /tmp/part-include
333
334     report_pre_failure_with_msg "ERROR: Specified installation ($orig_rootfs_device) or boot ($orig_boot_device) device is invalid."
335 fi
336
337 # Ensure specified device is not a USB drive
338 udevadm info --query=property --name=$rootfs_device |grep -q '^ID_BUS=usb' || \
339     udevadm info --query=property --name=$boot_device |grep -q '^ID_BUS=usb'
340 if [ $? -eq 0 ]; then
341     # Touch this file to prevent Anaconda from dying an ungraceful death
342     touch /tmp/part-include
343
344     report_pre_failure_with_msg "ERROR: Specified installation ($orig_rootfs_device) or boot ($orig_boot_device) device is a USB drive."
345 fi
346
347 # Deactivate existing volume groups to avoid Anaconda issues with pre-existing groups
348 vgs --noheadings -o vg_name | xargs --no-run-if-empty -n 1 vgchange -an
349
350 # Remove volumes and group for cgts-vg, if any
351 lvremove --force cgts-vg
352 pvs --select 'vg_name=cgts-vg' --noheadings -o pv_name | xargs --no-run-if-empty pvremove --force --force --yes
353 vgs --select 'vg_name=cgts-vg' --noheadings -o vg_name | xargs --no-run-if-empty vgremove --force
354
355 ONLYUSE_HDD=""
356 if [ "$(curl -sf http://pxecontroller:6385/v1/upgrade/$(hostname)/in_upgrade 2>/dev/null)" = "true" ]; then
357     # In an upgrade, only wipe the disk with the rootfs and boot partition
358     echo "In upgrade, wiping only $rootfs_device"
359     WIPE_HDD="$(get_disk $rootfs_device)"
360     ONLYUSE_HDD="$(basename $(get_disk $rootfs_device))"
361     if [ "$(get_disk $rootfs_device)" != "$(get_disk $boot_device)" ]; then
362         WIPE_HDD="$WIPE_HDD,$(get_disk $boot_device)"
363         ONLYUSE_HDD="$ONLYUSE_HDD,$(basename $(get_disk $boot_device))"
364     fi
365 else
366     # Make a list of all the hard drives that are to be wiped
367     WIPE_HDD=""
368     # Partition type OSD has a unique globally identifier
369     part_type_guid_str="Partition GUID code"
370     CEPH_OSD_GUID="4FBD7E29-9D25-41B8-AFD0-062C0CEFF05D"
371
372     # Check if we wipe OSDs
373     if [ "$(curl -sf http://pxecontroller:6385/v1/ihosts/wipe_osds 2>/dev/null)" = "true" ]; then
374         echo "Wipe OSD data."
375         WIPE_CEPH_OSDS="true"
376     else
377         echo "Skip Ceph OSD data wipe."
378         WIPE_CEPH_OSDS="false"
379     fi
380
381     for f in /dev/disk/by-path/*
382     do
383         dev=$(readlink -f $f)
384         lsblk --nodeps --pairs $dev | grep -q 'TYPE="disk"'
385         if [ $? -ne 0 ]
386         then
387             continue
388         fi
389
390         # Avoid wiping USB drives
391         udevadm info --query=property --name=$dev |grep -q '^ID_BUS=usb' && continue
392
393         # Avoid wiping ceph osds if sysinv tells us so
394         if [ ${WIPE_CEPH_OSDS} == "false" ]; then
395             wipe_dev="true"
396             part_numbers=( `parted -s $dev print | awk '$1 == "Number" {i=1; next}; i {print $1}'` )
397             # Scanning the partitions looking for CEPH OSDs and
398             # skipping any disk found with such partitions
399             for part_number in "${part_numbers[@]}"; do
400                 sgdisk_part_info=$(flock $dev sgdisk -i $part_number $dev)
401                 part_type_guid=$(echo "$sgdisk_part_info" | grep "$part_type_guid_str" | awk '{print $4;}')
402                 if [ "$part_type_guid" == $CEPH_OSD_GUID ]; then
403                     echo "OSD found on $dev, skipping wipe"
404                     wipe_dev="false"
405                     break
406                 fi
407             done
408             if [ "$wipe_dev" == "false" ]; then
409                 continue
410             fi
411         fi
412
413         # Add device to the wipe list
414         devname=$(basename $dev)
415         if [ -e $dev -a "$ISO_DEV" != "../../$devname" -a "$USB_DEV" != "../../$devname" ]; then
416             if [ -n "$WIPE_HDD" ]; then
417                 WIPE_HDD=$WIPE_HDD,$dev
418             else
419                 WIPE_HDD=$dev
420             fi
421         fi
422     done
423     echo "Not in upgrade, wiping disks: $WIPE_HDD"
424 fi
425
426 for dev in ${WIPE_HDD//,/ }
427 do
428     # Clearing previous GPT tables or LVM data
429     # Delete the first few bytes at the start and end of the partition. This is required with
430     # GPT partitions, they save partition info at the start and the end of the block.
431     # Do this for each partition on the disk, as well.
432     partitions=$(lsblk -rip $dev -o TYPE,NAME |awk '$1 == "part" {print $2}')
433     for p in $partitions $dev
434     do
435         echo "Pre-wiping $p from kickstart"
436         dd if=/dev/zero of=$p bs=512 count=34
437         dd if=/dev/zero of=$p bs=512 count=34 seek=$((`blockdev --getsz $p` - 34))
438     done
439 done
440
441 # Check for remaining cgts-vg PVs, which could potentially happen
442 # in an upgrade where we're not wiping all disks.
443 # If we ever create other volume groups from kickstart in the future,
444 # include them in this search as well.
445 partitions=$(pvs --select 'vg_name=cgts-vg' -o pv_name --noheading | grep -v '\[unknown\]')
446 for p in $partitions
447 do
448     echo "Pre-wiping $p from kickstart (cgts-vg present)"
449     dd if=/dev/zero of=$p bs=512 count=34
450     dd if=/dev/zero of=$p bs=512 count=34 seek=$((`blockdev --getsz $p` - 34))
451 done
452
453 let -i gb=1024*1024*1024
454
455 cat<<EOF>/tmp/part-include
456 clearpart --all --drives=$WIPE_HDD --initlabel
457 EOF
458
459 if [ -n "$ONLYUSE_HDD" ]; then
460     cat<<EOF>>/tmp/part-include
461 ignoredisk --only-use=$ONLYUSE_HDD
462 EOF
463 fi
464
465 if [ -d /sys/firmware/efi ] ; then
466     cat<<EOF>>/tmp/part-include
467 part /boot/efi --fstype=efi --size=300 --ondrive=$(get_disk $boot_device)
468 EOF
469 else
470     cat<<EOF>>/tmp/part-include
471 part biosboot --asprimary --fstype=biosboot --size=1 --ondrive=$(get_disk $boot_device)
472 EOF
473 fi
474
475
476 # Template from: pre_disk_storage.cfg
477
478 sz=$(blockdev --getsize64 $(get_disk $rootfs_device))
479 if [ $sz -le $((90*$gb)) ] ; then
480     LOG_VOL_SIZE=4000
481     SCRATCH_VOL_SIZE=4000
482     ROOTFS_SIZE=10000
483 else
484     LOG_VOL_SIZE=8000
485     SCRATCH_VOL_SIZE=8000
486     ROOTFS_SIZE=20000
487 fi
488
489 ROOTFS_OPTIONS="defaults"
490 profile_mode=`cat /proc/cmdline |xargs -n1 echo |grep security_profile= | grep extended`
491 if [ -n "$profile_mode" ]; then
492    # Enable iversion labelling for rootfs when IMA is enabled
493    ROOTFS_OPTIONS="${ROOTFS_OPTIONS},iversion"
494 fi
495
496 cat<<EOF>>/tmp/part-include
497 part /boot --fstype=ext4 --asprimary --size=500 --ondrive=$(get_disk $rootfs_device) --fsoptions="$ROOTFS_OPTIONS"
498 part pv.253004 --grow --asprimary --size=500 --ondrive=$(get_disk $rootfs_device)
499 volgroup cgts-vg --pesize=32768 pv.253004
500 logvol /var/log --fstype=ext4 --vgname=cgts-vg --size=$LOG_VOL_SIZE --name=log-lv
501 logvol /scratch --fstype=ext4 --vgname=cgts-vg --size=$SCRATCH_VOL_SIZE --name=scratch-lv
502 part / --fstype=ext4 --asprimary --size=$ROOTFS_SIZE --ondrive=$(get_disk $rootfs_device) --fsoptions="$ROOTFS_OPTIONS"
503
504 EOF
505
506 %end
507
508
509 # Template from: post_platform_conf_storage.cfg
510 %post --erroronfail
511
512 # Source common functions
513 . /tmp/ks-functions.sh
514
515 # Retrieve the installation uuid from the controller we booted from
516 http_port=$(get_http_port)
517 INSTALL_UUID=`curl -sf http://pxecontroller:${http_port:-8080}/feed/rel-19.12/install_uuid`
518 if [ $? -ne 0 ]
519 then
520   INSTALL_UUID=unknown
521 fi
522
523 # Set the security profile mode
524 secprofile="standard"
525 profile_mode=`cat /proc/cmdline |xargs -n1 echo |grep security_profile= | grep extended`
526 if [ -n "$profile_mode" ]; then
527    secprofile="extended"
528 fi
529
530 mkdir -p -m 0775 /etc/platform
531 cat <<EOF > /etc/platform/platform.conf
532 nodetype=storage
533 subfunction=storage
534 system_type=Standard
535 security_profile=$secprofile
536 INSTALL_UUID=$INSTALL_UUID
537 EOF
538
539 %end
540
541 # Template from: post_common.cfg
542 %post --erroronfail
543
544 # Source common functions
545 . /tmp/ks-functions.sh
546
547 # Turn off locale support for i18n if is not installed
548 if [ ! -d /usr/share/i18n ] ; then
549    rm -f /etc/sysconfig/i18n
550 fi
551 # Unset the hostname
552 rm /etc/hostname
553
554 # If using a serial install make sure to add a getty on the tty1
555 conarg=`cat /proc/cmdline |xargs -n1 echo |grep console= |grep ttyS`
556 if [ -n "$conarg" ] ; then
557    echo "1:2345:respawn:/sbin/mingetty tty1" >> /etc/inittab
558 fi
559
560 #### SECURITY PROFILE HANDLING (Post Installation) ####
561 # Check if the Security profile mode is enabled
562 # and load the appropriate kernel modules
563 secprofile=`cat /proc/cmdline |xargs -n1 echo |grep security_profile= | grep extended`
564 if [ -n "$secprofile" ]; then
565    echo "In Extended Security profile mode. Loading IMA kernel module"
566    systemctl enable auditd.service
567    # Add the securityfs mount for the IMA Runtime measurement list
568    echo "securityfs     /sys/kernel/security    securityfs    defaults,nodev 0 0" >> /etc/fstab
569 else
570    # Disable audit daemon in the Standard Security Profile
571    systemctl disable auditd
572 fi
573
574 . /etc/platform/platform.conf
575 # Configure smart package manager channels
576 rm -rf /var/lib/smart
577 mkdir /var/lib/smart
578 /usr/bin/smart channel -y \
579     --add rpmdb type=rpm-sys name="RPM Database"
580 /usr/bin/smart channel -y \
581     --add base type=rpm-md name="Base" baseurl=http://controller:${http_port:-8080}/feed/rel-19.12
582 /usr/bin/smart channel -y \
583     --add updates type=rpm-md name="Patches" baseurl=http://controller:${http_port:-8080}/updates/rel-19.12
584
585 # Configure smart to use rpm --nolinktos option
586 /usr/bin/smart config --set rpm-nolinktos=true
587
588 # Configure smart to use rpm --nosignature option
589 /usr/bin/smart config --set rpm-check-signatures=false
590
591 # Delete the CentOS yum repo files
592 rm -f /etc/yum.repos.d/CentOS-*
593
594 # Persist the boot device naming as UDEV rules so that if the network device
595 # order changes post-install that we will still be able to DHCP from the
596 # correct interface to reach the active controller.  For most nodes only the
597 # management/boot interface needs to be persisted but because we require both
598 # controllers to be identically configured and controller-0 and controller-1
599 # are installed differently (e.g., controller-0 from USB and controller-1 from
600 # network) it is not possible to know which interface to persist for
601 # controller-0.  The simplest solution is to persist all interfaces.
602 #
603 mkdir -p /etc/udev/rules.d
604 echo "# Persisted network interfaces from anaconda installer" > /etc/udev/rules.d/70-persistent-net.rules
605 for dir in /sys/class/net/*; do
606     if [ -e ${dir}/device ]; then
607        dev=$(basename ${dir})
608        mac_address=$(cat /sys/class/net/${dev}/address)
609        echo "ACTION==\"add\", SUBSYSTEM==\"net\", DRIVERS==\"?*\", ATTR{address}==\"${mac_address}\", NAME=\"${dev}\"" >> /etc/udev/rules.d/70-persistent-net.rules
610     fi
611 done
612
613 # Mark the sysadmin password as expired immediately
614 chage -d 0 sysadmin
615
616 # Lock the root password
617 passwd -l root
618
619 # Enable tmpfs mount for /tmp
620 # delete /var/tmp so that it can similinked in
621 rm -rf /var/tmp
622 systemctl enable tmp.mount
623
624 # Disable automount of /dev/hugepages
625 systemctl mask dev-hugepages.mount
626
627 # Disable firewall
628 systemctl disable firewalld
629
630 # Disable libvirtd
631 systemctl disable libvirtd.service
632
633 # Enable rsyncd
634 systemctl enable rsyncd.service
635
636 # Allow root to run sudo from a non-tty (for scripts running as root that run sudo cmds)
637 echo 'Defaults:root !requiretty' > /etc/sudoers.d/root
638
639 # Make fstab just root read/writable
640 chmod 600 /etc/fstab
641
642 # Create first_boot flag
643 touch /etc/platform/.first_boot
644
645 %end
646
647 # Template from: post_kernel_storage.cfg
648 %post --erroronfail
649
650 # Source common functions
651 . /tmp/ks-functions.sh
652
653 ## Custom kernel options
654 KERN_OPTS=" intel_iommu=off usbcore.autosuspend=-1"
655 ## Add kernel options to ensure an selinux is disabled
656 KERN_OPTS="${KERN_OPTS} selinux=0 enforcing=0"
657
658 # Add kernel options to ensure NMI watchdog is enabled, if supported
659 KERN_OPTS="${KERN_OPTS} nmi_watchdog=panic,1 softlockup_panic=1"
660
661 # Add kernel option to disable biosdevname if enabled
662 # As this may already be in GRUB_CMDLINE_LINUX, only add if it is not already present
663 grep -q '^GRUB_CMDLINE_LINUX=.*biosdevname=0' /etc/default/grub
664 if [ $? -ne 0 ]; then
665     KERN_OPTS="${KERN_OPTS} biosdevname=0"
666 fi
667
668 # k8s updates:
669 #KERN_OPTS="${KERN_OPTS} cgroup_disable=memory"
670 KERN_OPTS="${KERN_OPTS} user_namespace.enable=1"
671
672 # If the installer asked us to use security related kernel params, use
673 # them in the grub line as well (until they can be configured via puppet)
674 grep -q 'nopti' /proc/cmdline
675 if [ $? -eq 0 ]; then
676     KERN_OPTS="${KERN_OPTS} nopti"
677 fi
678 grep -q 'nospectre_v2' /proc/cmdline
679 if [ $? -eq 0 ]; then
680     KERN_OPTS="${KERN_OPTS} nospectre_v2"
681 fi
682
683 perl -pi -e 's/(GRUB_CMDLINE_LINUX=.*)\"/\1'"$KERN_OPTS"'\"/g' /etc/default/grub
684
685 if [ -d /sys/firmware/efi ] ; then
686   grub2-mkconfig -o /boot/efi/EFI/centos/grub.cfg
687 else
688   grub2-mkconfig -o /boot/grub2/grub.cfg
689 fi
690
691 %end
692
693
694 # Template from: post_lvm_pv_on_rootfs.cfg
695 %post --erroronfail
696
697 # Source common functions
698 . /tmp/ks-functions.sh
699
700 # uncomment the global_filter line in lvm.conf
701 perl -0777 -i.bak -pe 's:(# This configuration option has an automatic default value\.\n)\t# global_filter:$1        global_filter:m' /etc/lvm/lvm.conf
702
703 # Determine which disk we created our PV on (i.e. the root disk)
704 ROOTDISK=$(get_by_path $(pvdisplay --select 'vg_name=cgts-vg' -C -o pv_name --noheadings))
705 if [ -z "$ROOTDISK" ]; then
706     report_post_failure_with_msg "ERROR: failed to identify rootdisk via pvdisplay"
707 fi
708 # Edit the LVM config so LVM only looks for LVs on the root disk
709 sed -i "s#^\( *\)global_filter = \[.*#\1global_filter = [ \"a|${ROOTDISK}|\", \"r|.*|\" ]#" /etc/lvm/lvm.conf
710 %end
711
712
713 # Template from: post_net_common.cfg
714 %pre --erroronfail
715
716 # Source common functions
717 . /tmp/ks-functions.sh
718
719 http_port=$(get_http_port)
720 echo "repo --name=base --baseurl=http://pxecontroller:${http_port:-8080}/feed/rel-19.12/" > /tmp/repo-include
721 echo "repo --name=updates --baseurl=http://pxecontroller:${http_port:-8080}/updates/rel-19.12/" > /tmp/repo-include
722
723 %end
724
725 # Repository arguments from %pre
726 %include /tmp/repo-include
727
728
729 %post --erroronfail
730
731 # Source common functions
732 . /tmp/ks-functions.sh
733
734 # Persist the http port to the platform configuration
735 echo http_port=$(get_http_port) >> /etc/platform/platform.conf
736
737 # Obtain the boot interface from the PXE boot
738 BOOTIF=`cat /proc/cmdline |xargs -n1 echo |grep BOOTIF=`
739 if [ -d /sys/firmware/efi ] ; then
740     BOOTIF=${BOOTIF#BOOTIF=}
741 else
742     BOOTIF=${BOOTIF#BOOTIF=01-}
743     BOOTIF=${BOOTIF//-/:}
744 fi
745
746 mgmt_dev=none
747 mgmt_vlan=0
748 if [ -n "$BOOTIF" ] ; then
749     ndev=`ip link show |grep -B 1 $BOOTIF |head -1 |awk '{print $2}' |sed -e 's/://'`
750     if [ -n "$ndev" ] ; then
751         mgmt_dev=$ndev
752         # Retrieve the management VLAN from sysinv if it exists
753         mgmt_vlan=`curl -sf http://pxecontroller:6385/v1/isystems/mgmtvlan`
754         if [ $? -ne 0 ]
755         then
756           report_post_failure_with_msg "ERROR: Unable to communicate with System Inventory REST API. Aborting installation."
757         fi
758     else
759         report_post_failure_with_msg "ERROR: Unable to determine mgmt interface from BOOTIF=$BOOTIF."
760     fi
761 else
762     report_post_failure_with_msg "ERROR: BOOTIF is not set. Unable to determine mgmt interface."
763 fi
764
765 if [ $mgmt_vlan -eq 0 ] ; then
766
767     # Persist the boot device to the platform configuration. This will get
768     # overwritten later if the management_interface is on a bonded interface.
769     echo management_interface=$mgmt_dev >> /etc/platform/platform.conf
770
771     # Build networking scripts
772     cat << EOF > /etc/sysconfig/network-scripts/ifcfg-lo
773 DEVICE=lo
774 IPADDR=127.0.0.1
775 NETMASK=255.0.0.0
776 NETWORK=127.0.0.0
777 BROADCAST=127.255.255.255
778 ONBOOT=yes
779 IPV6_AUTOCONF=no
780 NAME=loopback
781 EOF
782
783     cat << EOF > /etc/sysconfig/network-scripts/ifcfg-$mgmt_dev
784 DEVICE=$mgmt_dev
785 BOOTPROTO=dhcp
786 ONBOOT=yes
787 IPV6_AUTOCONF=no
788 LINKDELAY=20
789 EOF
790
791 else
792
793     # Check whether to use inet or inet6
794     ipv6_addr=$(dig +short AAAA controller)
795     if [[ -n "$ipv6_addr" ]]
796     then
797         mgmt_address_family=inet6
798         ipv6init=yes
799         dhcpv6c=yes
800         dhclientargs=-1
801     else
802         mgmt_address_family=inet
803         ipv6init=no
804         dhcpv6c=no
805         dhclientargs=
806     fi
807
808     # Persist the boot device to the platform configuration. This will get
809     # overwritten later if the management_interface is on a bonded interface.
810     echo management_interface=vlan$mgmt_vlan >> /etc/platform/platform.conf
811
812     # Build networking scripts
813     cat << EOF > /etc/sysconfig/network-scripts/ifcfg-lo
814 DEVICE=lo
815 IPADDR=127.0.0.1
816 NETMASK=255.0.0.0
817 NETWORK=127.0.0.0
818 BROADCAST=127.255.255.255
819 ONBOOT=yes
820 IPV6_AUTOCONF=no
821 NAME=loopback
822 EOF
823
824     cat << EOF > /etc/sysconfig/network-scripts/ifcfg-$mgmt_dev
825 DEVICE=$mgmt_dev
826 BOOTPROTO=none
827 ONBOOT=yes
828 IPV6_AUTOCONF=no
829 LINKDELAY=20
830 EOF
831
832     cat << EOF > /etc/sysconfig/network-scripts/ifcfg-vlan$mgmt_vlan
833 DEVICE=vlan$mgmt_vlan
834 BOOTPROTO=dhcp
835 DHCLIENTARGS=$dhclientargs
836 IPV6INIT=$ipv6init
837 DHCPV6C=$dhcpv6c
838 ONBOOT=yes
839 IPV6_AUTOCONF=no
840 PHYSDEV=$mgmt_dev
841 VLAN=yes
842 LINKDELAY=20
843 EOF
844
845     # Reject DHCPOFFER from DHCP server that doesn't send
846     # wrs-install-uuid option
847     echo "require wrs-install-uuid;" >>/etc/dhcp/dhclient.conf
848     echo "require dhcp6.wrs-install-uuid;" >>/etc/dhcp/dhclient.conf
849
850     # Bring up the mgmt vlan so that a dhcp lease is acquired and an address is
851     # setup prior to the post-install reboot.  This is so that the timing of the IP
852     # address allocation is similar to how normal/non-pxe installation works.
853     mgmt_iface=vlan$mgmt_vlan
854     dhclient_family=$([[ $mgmt_address_family == "inet" ]] && echo -4 || echo -6)
855     ip link add link $mgmt_dev name $mgmt_iface type vlan id $mgmt_vlan
856     ip link set up dev $mgmt_iface
857     dhclient $dhclient_family $mgmt_iface || true
858
859 fi
860
861 %end